package com.realnet.dlf.Controllers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.realnet.dlf.Entity.Dlf_header;
import com.realnet.dlf.Services.Dlf_headerService;
import com.realnet.fnd.response.EntityResponse;

@RequestMapping(value = "/Dlf_header")
@CrossOrigin("*")
@RestController
public class Dlf_headerController {
	@Autowired
	private Dlf_headerService Service;

	@Value("${projectPath}")
	private String projectPath;

	@PostMapping("/Dlf_header")
	public Dlf_header Savedata(@RequestBody Dlf_header data) {
		Dlf_header save = Service.Savedata(data);

		System.out.println("data saved..." + save);

		return save;
	}

	@PutMapping("/Dlf_header/{id}")
	public Dlf_header update(@RequestBody Dlf_header data, @PathVariable Integer id) {
		Dlf_header update = Service.update(data, id);
		System.out.println("data update..." + update);
		return update;
	}

//	get all with pagination
	@GetMapping("/Dlf_header/getall/page")
	public Page<Dlf_header> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Dlf_header> get = Service.getAllWithPagination(paging);

		return get;

	}

	@GetMapping("/Dlf_header")
	public List<Dlf_header> getdetails() {
		List<Dlf_header> get = Service.getdetails();
		return get;
	}
// get all without authentication 

	@GetMapping("/token/Dlf_header")
	public List<Dlf_header> getallwioutsec() {
		List<Dlf_header> get = Service.getdetails();
		return get;
	}

	@GetMapping("/Dlf_header/{id}")
	public Dlf_header getdetailsbyId(@PathVariable Integer id) {
		Dlf_header get = Service.getdetailsbyId(id);
		return get;
	}

	@DeleteMapping("/Dlf_header/{id}")
	public ResponseEntity<?> delete_by_id(@PathVariable Integer id) {
		Service.delete_by_id(id);
		return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);

	}

}